#! /usr/bin/env python

## soth master node v0.1 02/08/2000 copyright S Kodela
## todo : change log file writing to a keyword logfile from soth config.

from socket import *
import string,time,sys

# some vars
conprefix="conn"
jobfname=sys.argv[1]
logfname="soth.log"
portnum=5000
sysq={}
sysbusyq={}
runq={}
errlst=[]
msglst=[]
cmtlst=[]
joblog=[]
optdict={}
incdict={}
licence="\n\n\tSoth Distributed Processing Environment\tv0.1\n\t\tCopyright S . Kodela \tThankyou for using Soth\n\n" 
def printuline():
    print "============================================================"
    
def tmnow():
    return  time.asctime(time.gmtime(time.time()))+" ::  "

def perror(x):
    print "ERROR :: "+str(x)

def pcomment():
    print "COMMENTS"
    for n in cmtlst:
        print "COMMENT :: "+n
        
def printerror():
    print "ERROR MESSAGES"
    printuline()
    for n in errlst:
        perror(n)

def printjoblog():
    print "EXEC LOGS"
    printuline()
    for n in joblog:
        print "EXEC : "+n

def printlog():
    print "SOTH LOGS"
    printuline()
    for n in msglst:
        print "LOG :: "+n

def printrubbish():
    print "SYSTEM VARS"
    print "LOGFILE  : "+logfname
    print "PORTNUM  : "+str(portnum)
    print "EXECFILE : "+jobfname
    print "TIMESTA  : "+tmsta
    print "TIMEEND  : "+tmend
    try:
        for n in optdict.keys():
            print n,'  ::  ',optdict[n]
        for n in cmtlst:
            print 'COMMENT :: '+n
    except:
        passn
    
def writelogs():
    uline="\t============================================\n"
    try:
        if optdict.has_key("logfname"):
            logfname=optdict["logfname"]
        f=open(logfname,"w")
        f.write(tmnow())
        f.write(licence)
        f.write(uline)
        for n in msglst:
            f.write("LOG :: "+n+'\n')
        f.write(uline)
        for n in joblog:
            f.write("EXEC :: "+n+'\n')
        f.write(uline)
        for n in errlst:
            f.write("ERROR :: "+n+'\n')
        f.write(uline)
        for n in cmtlst:
            f.write("COMMENT :: "+n+'\n')
        f.write(uline)
        f.close()
    except:
        print "Oops : Could not open soth.log for writing"

def stillmore():
    for n in runq.keys():
	if runq[n]=="PEND":
	    return 1

def cleanup(x):
    x=string.replace(x,".","_")
    x=string.replace(x,":","_")
    return x

def shutremote():
    for n in sysq.keys():
        tmp=socket(AF_INET,SOCK_STREAM)
        tmp.connect(n,portnum)
        tmp.send("QUIT")
        del tmp
       
#pasre file
def parser(x):
    tempdata=string.split(x,"==")
    tempdata[0]=string.upper(string.strip(tempdata[0]))
    if tempdata[0]=="SYS":
        sysq[tempdata[1]]="PEND"
    elif tempdata[0]=="COMMENT":
        cmtlst.append(tempdata[1])
    elif tempdata[0]=="POLL":
        optdict["polltime"]=str(tempdata[1])
    elif tempdata[0]=="EXEC":
        runq[str(tempdata[1])]="PEND"
    elif tempdata[0]=="SHUT":
        optdict["shutdown"]=str(tempdata[1])
    elif tempdata[0]=="PORT":
        optdict["portnum"]=str(tempdata[1])
    elif tempdata[0]=="LOGFILE":
        optdict["logfname"]=tempdata[1]
    elif tempdata[0]=="LOGWRITE":
        optdict["logwrite"]=str(tempdata[1])
    elif tempdata[0]=="INCLUDE":
        try:
            try:
                incdat=open(tempdata[1],'r').read()
            except:
                errlst.append("Could not open include file."+tempdata[1])
            for n in string.split(incdat,'\n'):
                try:
                    tmpinc=string.split(n,'==')
                    incdict[tmpinc[0]]=tmpinc[1]
                except:
                    errlst.append("Some illegal string in include : "+n)
        except:
            errlst.append("Error in include file  "+tempdata[1])
    else:
        errlst.append(tmnow()+"Unknown statement : "+x)

def fparse():
    try:
        predata=open(jobfname).read()
        try: #split strings
            predata=string.split(predata,"\n")
        except:
            errlst.append("Something wrong while splitting strings in runfile")
        for n in predata: # parse em
            parser(n)
        try: #see if any sense in included file
            for n in incdict.keys():
                parser(n+'=='+incdict[n])
        except:
            pass
    except:
        errlst.append(tmnow()+"Could not open input file!!")
        printerror()
        raise SystemExit
        
#hlth check
def healthchk(remove):
    for n in sysq.keys():
        tmp=socket(AF_INET,SOCK_STREAM)
        try: # connect send recieve
            tmp.connect(n,portnum)
            try:
                tmp.send("READY")
                resp=tmp.recv(1024)
            except:
                pass
            tmp.close()
        except: # no connection
            errlst.append("System not responding : "+n)
        try:
            if resp=="READY":
                sysbusyq[n]="READY"
                msglst.append(tmnow()+n+" is healthy")
        except:
            pass

#send jobs
def sender():
    for n in runq.keys():
        if runq[n]=="PEND":
	    for m in sysq.keys():
                try:
                    if sysbusyq[m]=="READY":
                        tmp=socket(AF_INET,SOCK_STREAM)
                        tmp.connect(m,portnum)
                        try:
                            tmp.send(str(n))
                        except:
                            errmsg.append(tmnow()+"Error sending job : "+n+" to "+m)
                        tmp.close()
                        joblog.append(tmnow()+"Job "+n+" sent to "+m)
                        sysbusyq[m]="BUSY"
                        runq[n]="SENT"
                        break
                except:
                    pass
    

##########################################
##########################################
### Main run body...
# read input and healthcheck
fparse()
healthchk(1)
tmsta=tmnow()

# see if a different port given
if optdict.has_key("portnum"):
    portnum=int(optdict["portnum"])
    
# loop over jobs
while stillmore():
    healthchk(0)
    sender()
    if optdict.has_key("polltime"):
        time.sleep(int(optdict["polltime"]))
    
# if shutdown then close remotes
if optdict.has_key("shutdown"):
    if int(optdict["shutdown"])==1:
        shutremote()

tmend=tmnow()

# print and save logs
try:
    print "\n\n"
    print tmnow()
    print licence
    printlog()
    printjoblog()
    printerror()
    printrubbish()
except:
    pass

##see if user wants a log file
if optdict.has_key("logwrite"):
    if int(optdict["logwrite"])==1:
        writelogs()









